<template>
  <authenticated>
    <div class="shadow-lg bg-white p-5">
      <div class="grid col-span-1 md:grid-cols-2 lg:grid-cols-5 gap-5">
        <div
          class="
            col-span-full
            grid grid-cols-2
            md:grid-cols-3
            lg:grid-cols-4
            gap-3
          "
        >
          <div
            v-for="(stargic, i) in stargics"
            :key="stargic.id"
            :class="`shadow-md
              bg-gradient-to-r
              ${
                i == 1
                  ? 'from-green-600 to-blue-300'
                  : i == 2
                  ? 'from-blue-300 to-purple-600'
                  : i == 0
                  ? 'from-yellow-300 to-green-600'
                  : 'from-purple-600 to-pink-300'
              }
              rounded-lg
              text-white
              p-4`"
          >
            <h3 class="text-lg md:text-xl font-bold">
              {{ stargic.name }}
            </h3>
            <span>( {{ stargic.children.length }} โครงการหลัก )</span>
            <p
              class="text-xs md:text-sm"
              v-if="
                stargic.children.reduce((a, b) => a + b.children.length, 0) > 0
              "
            >
              (
              {{
                stargic.children.reduce(
                  (a, b) =>
                    a + b.children.reduce((a, b) => a + b.children.length, 0),
                  0
                )
              }}
              โครงการย่อย )
            </p>
          </div>
        </div>
        <div class="col-span-1 lg:col-span-2 grid gap-5">
          <div>
            <div class="grid">
              <el-select
                v-model="form.budget_year_id"
                filterable
                placeholder="ปีงบประมาณ"
                @change="budgetYearsChange"
              >
                <el-option
                  v-for="item in budget_years"
                  :key="item.id"
                  :label="item.year"
                  :value="item.id"
                >
                </el-option>
              </el-select>
            </div>
            <div class="mt-3"></div>
            <b class="text-lg md:text-xl">สรุปงบประมาณของแต่ละยุทธศาสตร์</b>
            <vue3-chart-js v-bind="{ ...pieChartStargic }" />
          </div>
        </div>
        <div class="col-span-1 lg:col-span-3">
          <tree-node-project :stargics="stargics" />
        </div>
      </div>
    </div>
  </authenticated>
</template>

<script>
import Vue3ChartJs from "@j-t-mcc/vue3-chartjs";
import Authenticated from "@/Layouts/Authenticated.vue";
import { reactive, toRefs, onMounted, computed } from "vue";
import { Inertia } from "@inertiajs/inertia";
import TreeNodeProject from "@/Components/TreeNodeProject.vue";

export default {
  name: "App",
  components: {
    Vue3ChartJs,
    Authenticated,
    TreeNodeProject,
  },
  props: {
    budget_years: Array,
    stargics: Array,
    chart: Array,
  },
  setup(props) {
    const { budget_years, stargics, chart } = toRefs(props);
    const form = reactive({
      budget_year_id: route()?.params?.budgetYearId
        ? parseInt(route()?.params?.budgetYearId)
        : budget_years.value.length > 0
        ? 1
        : null,
    });

    const budgetYearsChange = () => {
      Inertia.get(route("admin.dashboard.index"), {
        budgetYearId: form.budget_year_id,
      });
    };
    const pieChartStargic = computed(() => {
      let labels = [];
      let total = [];
      chart.value.forEach((data) => {
        labels.push(data.name);
        total.push(data.total);
      });

      return {
        type: "pie",
        data: {
          labels: labels,
          datasets: [
            {
              backgroundColor: ["#FFBF00", "#9FE2BF", "#CCCCFF", "#DE3163"],
              data: total,
            },
          ],
        },
      };
    });
    return {
      form,
      budgetYearsChange,
      pieChartStargic,
      budget_years,
      stargics,
    };
  },
};
</script>

